searchNodes=[{"doc":"AuthPlug handles all our auth needs in just a handful of lines of code. Please see README.md for setup instructions.","ref":"AuthPlug.html","title":"AuthPlug","type":"module"},{"doc":"call/2 is invoked to handle each HTTP request which auth_plug protects. If the conn contains a valid JWT in Authentication Headers, jwt query parameter or Phoenix Session, then continue to the protected route, else redirect to the auth_url with the referer set as the continuation URL.","ref":"AuthPlug.html#call/2","title":"AuthPlug.call/2","type":"function"},{"doc":"","ref":"AuthPlug.html#create_jwt_session/2","title":"AuthPlug.create_jwt_session/2","type":"function"},{"doc":"end_session/1 makes an HTTP Request to the auth_url to end the session. This in turn makes the update on the auth app to update the session.end so the owner of the &quot;consumer&quot; app knows when the person logged out. end_session/1 is invoked by AuthPlug.logout/1 (above) which will likely be the function called in practice.","ref":"AuthPlug.html#end_session/1","title":"AuthPlug.end_session/1","type":"function"},{"doc":"get_auth_url/2 returns a string representing the auth url. The first parameter is conn , the second is optional and represents the endpoint in your application where the auth application will redirect to after authentication. By default the second parameter value is conn.request_path which represents the current path. Examples iex&gt; AuthPlug.get_auth_url(conn) &quot; https://dwylauth.herokuapp.com/?referer=https://www.example.com/&amp;auth_client_id=123123&quot; iex&gt; AuthPlug.get_auth_url(conn, &quot;/mypage) &quot; https://dwylauth.herokuapp.com/?referer=https://www.example.com/mypage&amp;auth_client_id=123123&quot;","ref":"AuthPlug.html#get_auth_url/2","title":"AuthPlug.get_auth_url/2","type":"function"},{"doc":"init/1 initialises the options passed in and makes them available in the lifecycle of the call/2 invocation (below). We pass in the auth_url key/value with the URL of the Auth service to redirect to if session is invalid/expired.","ref":"AuthPlug.html#init/1","title":"AuthPlug.init/1","type":"function"},{"doc":"logout/1 does exactly what you expect; logs the person out of your app. recieves a conn (Plug.Conn) and unsets the session. This is super-useful in testing as we can easily reset a session.","ref":"AuthPlug.html#logout/1","title":"AuthPlug.logout/1","type":"function"},{"doc":"","ref":"AuthPlug.Application.html","title":"AuthPlug.Application","type":"module"},{"doc":"Callback implementation for Application.start/2 .","ref":"AuthPlug.Application.html#start/2","title":"AuthPlug.Application.start/2","type":"function"},{"doc":"This is a TestDouble for HTTPoison which returns a predictable response. Please see: https://github.com/dwyl/elixir-auth-google/issues/35","ref":"AuthPlug.HTTPoisonMock.html","title":"AuthPlug.HTTPoisonMock","type":"module"},{"doc":"post/2 using a dummy _url to test body decoding.","ref":"AuthPlug.HTTPoisonMock.html#post/2","title":"AuthPlug.HTTPoisonMock.post/2","type":"function"},{"doc":"","ref":"AuthPlug.Helpers.html","title":"AuthPlug.Helpers","type":"module"},{"doc":"check_environment_vars/0 displays a friendly error message if the AUTH_API_KEY environment variable is not defined.","ref":"AuthPlug.Helpers.html#check_environment_vars/0","title":"AuthPlug.Helpers.check_environment_vars/0","type":"function"},{"doc":"get_baseurl_from_conn/1 derives the base URL from the conn struct e.g: http://localhost:4000 or https://app.dwyl.com","ref":"AuthPlug.Helpers.html#get_baseurl_from_conn/1","title":"AuthPlug.Helpers.get_baseurl_from_conn/1","type":"function"},{"doc":"strip_struct_metadata/1 removes the Ecto Struct metadata from a struct. This is essential before attempting to create a JWT as Jason.encode/2 chokes on any invalid data. See: github.com/dwyl/auth_plug/issues/16","ref":"AuthPlug.Helpers.html#strip_struct_metadata/1","title":"AuthPlug.Helpers.strip_struct_metadata/1","type":"function"},{"doc":"","ref":"AuthPlug.Router.html","title":"AuthPlug.Router","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"AuthPlug.Router.html#call/2","title":"AuthPlug.Router.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"AuthPlug.Router.html#init/1","title":"AuthPlug.Router.init/1","type":"function"},{"doc":"Token module to create and validate jwt. see https://hexdocs.pm/joken/configuration.html#module-approach","ref":"AuthPlug.Token.html","title":"AuthPlug.Token","type":"module"},{"doc":"api_key/0 retrieves the API_KEY from environment variable. API keys are a single environment variable which is comprised of two parts. client_id/client_secret such that splitting on the &quot;/&quot; (forward slash) gives us the client_id and client_secret example: 2cfxNaWUwJBq1F4nPndoEHZJ5YCCNq9JDNAAR/2cfxNadrhMZk3iaT1L5k6Wt67c9ScbGNPz8Bw/dwylauth.herokuapp.com see: https://github.com/dwyl/auth/issues/42#issuecomment-620247243","ref":"AuthPlug.Token.html#api_key/0","title":"AuthPlug.Token.api_key/0","type":"function"},{"doc":"auth_url/0 returns the auth_url (the last part of the AUTH_API_KEY)","ref":"AuthPlug.Token.html#auth_url/0","title":"AuthPlug.Token.auth_url/0","type":"function"},{"doc":"client_id/0 returns the client_id (the first part of the AUTH_API_KEY)","ref":"AuthPlug.Token.html#client_id/0","title":"AuthPlug.Token.client_id/0","type":"function"},{"doc":"client_secret/0 returns the client_secret (the middle part of the AUTH_API_KEY)","ref":"AuthPlug.Token.html#client_secret/0","title":"AuthPlug.Token.client_secret/0","type":"function"},{"doc":"create_jwt_session/2 recieves a conn (Plug.Conn) and claims e.g: %{email: &quot;person@dwyl.com&quot;, id: 1} . Signs a JWT which gets attached to the session. This is super-useful in testing as we can simply invoke create_jwt_session(conn, %{email: &quot;al@ex.co&quot;, id: 1}) and continue the request pipeline with a valid session.","ref":"AuthPlug.Token.html#create_jwt_session/2","title":"AuthPlug.Token.create_jwt_session/2","type":"function"},{"doc":"create_session/2 takes a conn , claims and a JWT and creates the session using Phoenix Sessions and the JWT as the value so that it can be checked on each future request. Makes the decoded JWT available in conn.assigns.person which means it can be used in templates.","ref":"AuthPlug.Token.html#create_session/3","title":"AuthPlug.Token.create_session/3","type":"function"},{"doc":"create_signer/1 creates a signer for the given secret key. It uses the HS256 (HMAC with SHA-256) to generate the signature. if you're wondering what &quot;HS256&quot; is, read: community.auth0.com/t/jwt-signing-algorithms-rs256-vs-hs256/7720","ref":"AuthPlug.Token.html#create_signer/1","title":"AuthPlug.Token.create_signer/1","type":"function"},{"doc":"Combines generate_claims/1 and encode_and_sign/2","ref":"AuthPlug.Token.html#generate_and_sign/2","title":"AuthPlug.Token.generate_and_sign/2","type":"function"},{"doc":"Same as generate_and_sign/2 but raises if error","ref":"AuthPlug.Token.html#generate_and_sign!/2","title":"AuthPlug.Token.generate_and_sign!/2","type":"function"},{"doc":"generate_jwt!/1 invokes Joken.generate_and_sign/3 claims are the data to be signed. Throws an error if anyting in the claims is invalid.","ref":"AuthPlug.Token.html#generate_jwt!/1","title":"AuthPlug.Token.generate_jwt!/1","type":"function"},{"doc":"generate_jwt!/2 invokes Joken.generate_and_sign/3 claims are the data to be signed and secret is the secret key.","ref":"AuthPlug.Token.html#generate_jwt!/2","title":"AuthPlug.Token.generate_jwt!/2","type":"function"},{"doc":"get_jwt/1 extracts the JWT from HTTP Request headers, URL or Cookie. If no JWT is found, it returns nil.","ref":"AuthPlug.Token.html#get_jwt/1","title":"AuthPlug.Token.get_jwt/1","type":"function"},{"doc":"put_current_token/3 takes a conn , JWT and values (decoded JWT) and creates the session using create_session/2 defined above.","ref":"AuthPlug.Token.html#put_current_token/3","title":"AuthPlug.Token.put_current_token/3","type":"function"},{"doc":"Combines verify/2 and validate/2","ref":"AuthPlug.Token.html#verify_and_validate/3","title":"AuthPlug.Token.verify_and_validate/3","type":"function"},{"doc":"Same as verify_and_validate/2 but raises if error","ref":"AuthPlug.Token.html#verify_and_validate!/3","title":"AuthPlug.Token.verify_and_validate!/3","type":"function"},{"doc":"verify_jwt/1 verifies the given JWT and returns {:ok, claims} where the claims are the original data that were signed.","ref":"AuthPlug.Token.html#verify_jwt/1","title":"AuthPlug.Token.verify_jwt/1","type":"function"},{"doc":"verify_jwt/2 verifies the given JWT and secret. Returns {:ok, claims} where the claims are the original data that were signed.","ref":"AuthPlug.Token.html#verify_jwt/2","title":"AuthPlug.Token.verify_jwt/2","type":"function"},{"doc":"verify_jwt!/1 verifies the given JWT and returns claims where the claims are the original data that were signed.","ref":"AuthPlug.Token.html#verify_jwt!/1","title":"AuthPlug.Token.verify_jwt!/1","type":"function"},{"doc":"verify_jwt!/2 verifies the given JWT and returns claims where the token is the JWT that was signed secret is the secret key. Returns claims the original claims contained in the JWT.","ref":"AuthPlug.Token.html#verify_jwt!/2","title":"AuthPlug.Token.verify_jwt!/2","type":"function"},{"doc":"AuthPlugOptional handles any route where authentication is optional e.g. if you're building a CMS where content is public but seeing comments requires auth, the same page can show different content depending on if the person has logged in or not. Please see README.md for for optional auth usage.","ref":"AuthPlugOptional.html","title":"AuthPlugOptional","type":"module"},{"doc":"call/2 is invoked to handle each HTTP request which auth_plug protects. If the conn contains a valid JWT in Authentication Headers, URL or Cookie, then continue to the optionally protected route with the conn.assigns.person defined so that the controller can determine what content to show the person. NOTE: this plug does NOT set the HTTP Status on a request, that is left to you.","ref":"AuthPlugOptional.html#call/2","title":"AuthPlugOptional.call/2","type":"function"},{"doc":"init/1 returns options unmodified","ref":"AuthPlugOptional.html#init/1","title":"AuthPlugOptional.init/1","type":"function"}]